'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.3.1
module.exports = function (BasePlugin) {
  var HighlightjsPlugin, balUtil, cache, extendr, hljs;
  // Requires
  balUtil = require('bal-util');
  extendr = require('extendr');
  hljs = require('highlight.js');
  cache = {};
  return HighlightjsPlugin = function () {
    var extractLanguage;

    // Define Plugin

    var HighlightjsPlugin = function (_BasePlugin) {
      _inherits(HighlightjsPlugin, _BasePlugin);

      function HighlightjsPlugin() {
        _classCallCheck(this, HighlightjsPlugin);

        return _possibleConstructorReturn(this, (HighlightjsPlugin.__proto__ || Object.getPrototypeOf(HighlightjsPlugin)).apply(this, arguments));
      }

      _createClass(HighlightjsPlugin, [{
        key: 'highlightSource',

        // Highlight an element
        value: function highlightSource(opts) {
          var aliases, className, config, docpad, err, escape, i, language, len, next, ref, removeIndentation, replaceTab, result, source, transform, transforms;
          // Prepare
          docpad = this.docpad;
          source = opts.source;
          language = opts.language;
          next = opts.next;

          config = extendr.extend({}, this.getConfig(), opts.config || {});
          var _config = config;
          escape = _config.escape;
          replaceTab = _config.replaceTab;
          aliases = _config.aliases;
          transforms = _config.transforms;
          removeIndentation = _config.removeIndentation;
          className = _config.className;

          if (removeIndentation !== false) {
            // Remove Indentation
            source = balUtil.removeIndentation(source);
          }
          // Extrat language
          language = extractLanguage(language);
          // Highlight
          result = source;
          if (language !== 'no-highlight') {
            // Correctly escape the source
            if (escape !== true) {
              // Unescape the output as highlightjs always escape
              source = require('he').decode(source);
            }
            ref = transforms || [];
            // Transforms
            for (i = 0, len = ref.length; i < len; i++) {
              transform = ref[i];
              if (transform instanceof Function) {
                // transforms = (source) ->
                source = transform(source, language);
              } else if (transform instanceof Array && transform.length === 2) {
                // transforms = ['find' or RegExp, 'replace']
                source = source.replace(transform[0], transform[1]);
              }
            }
            if (replaceTab) {
              // Replace tabs
              hljs.fixMarkup(source, replaceTab);
            }
            try {
              // Correct aliases
              // Highlight
              if (language && aliases[language]) {
                language = aliases[language];
              }
              // Perform the render
              if (language) {
                if (hljs.getLanguage(language)) {
                  result = hljs.highlight(language, source);
                } else {
                  docpad.warn('Highlight.js: Syntax highlight definition does not exist for language: ' + language + '\nYour probably want to add an alias for this language to one that we do support\nMore information here: https://github.com/docpad/docpad-plugin-highlightjs#language-aliases');
                  result = hljs.highlightAuto(source);
                }
              } else {
                result = hljs.highlightAuto(source);
              }
              // Extract the result
              language = result.language;
              result = result.value;
            } catch (error) {
              err = error;
              if (err) {
                return next(err);
              }
            }
          }
          // Handle
          result = ('<pre class="' + className + '"><code class="hljs ' + language + '">' + result + '</code></pre>').replace(/\t/g, replaceTab);
          next(null, result);
          return this;
        }

        // Render the document

      }, {
        key: 'renderDocument',
        value: function renderDocument(opts, _next) {
          var cacheKey, cacheResult, className, extension, file, plugin, ref;
          extension = opts.extension;
          file = opts.file;

          var _getConfig = this.getConfig();

          className = _getConfig.className;

          plugin = this;
          // Handle
          if (file.type === 'document' && extension === 'html') {
            // Check cache
            cacheKey = opts.content + ((ref = file.attributes.plugins) != null ? ref.highlightjs : void 0);
            cacheResult = cache[cacheKey];
            if (cacheResult) {
              opts.content = cacheResult;
              return _next();
            }
            // Grab all the code blocks
            return balUtil.replaceElementAsync({
              html: opts.content,
              element: 'pre',
              removeIndentation: false,
              replace: function replace(outerHTML, elementNameMatched, attributes, innerHTML, replaceElementCompleteCallback) {
                var classes;
                // Check
                classes = balUtil.getAttribute(attributes, 'class') || '';
                if (classes.indexOf(className) !== -1) {
                  return replaceElementCompleteCallback(null, outerHTML);
                }
                // Replace
                return balUtil.replaceElementAsync({
                  html: innerHTML,
                  element: 'code',
                  removeIndentation: false,
                  replace: function replace(outerHTML, elementNameMatched, attributes, innerHTML, replaceElementCompleteCallback) {
                    var ref1;
                    classes = balUtil.getAttribute(attributes, 'class') || '';
                    return plugin.highlightSource({
                      source: innerHTML,
                      language: classes,
                      config: (ref1 = file.attributes.plugins) != null ? ref1.highlightjs : void 0,
                      next: replaceElementCompleteCallback
                    });
                  },
                  next: replaceElementCompleteCallback
                });
              },
              next: function next(err, result) {
                if (err) {
                  return _next(err);
                }
                opts.content = result;
                cache[cacheKey] = result;
                return _next();
              }
            });
          } else {
            return _next();
          }
        }
      }]);

      return HighlightjsPlugin;
    }(BasePlugin);

    ;

    // Plugin name
    HighlightjsPlugin.prototype.name = 'highlightjs';

    // Plugin configuration
    HighlightjsPlugin.prototype.config = {
      replaceTab: '    ',
      transforms: null,
      escape: false,
      removeIndentation: false,
      className: 'highlight',
      aliases: {
        coffee: 'coffeescript',
        rb: 'ruby',
        js: 'javascript',
        html: 'xml',
        htm: 'xml',
        eco: 'xml',
        erb: 'xml',
        phtml: 'xml'
      }
    };

    // Extract language
    extractLanguage = function extractLanguage(str) {
      var matches;
      // Prepare
      str = (str || '').toLowerCase();
      if (/no[-]?highlight|none/i.test(str)) {
        // No highlighting
        return 'no-highlight';
      }
      // Return the last listed language class
      matches = str.match(/lang(?:uage)?-\w+/g);
      if (matches) {
        return matches.pop().match(/lang(?:uage)?-(\w+)/)[1];
      }
      if (str.indexOf(' ') === -1) {
        // Return the string if it is it
        return str;
      }
      // Auto-highlighting
      return '';
    };

    return HighlightjsPlugin;
  }.call(this);
};